#include "display.h"

void Send(uint16_t data)
{
	uint16_t tmp;

	PORT_DISPLAY &= ~(1<<DISP_CS);

	for(int i=15; i>=0; i--)
	{
		tmp = data & (1<<i);

		PORT_DISPLAY &= ~(1<<DISP_CLK);

		if(tmp > 0)
			PORT_DISPLAY |= (1<<DISP_DATA);
		else
			PORT_DISPLAY &= ~(1<<DISP_DATA);

		PORT_DISPLAY |= (1<<DISP_CLK);
	}

	PORT_DISPLAY &= ~(1<<DISP_CLK);

	// CS pulse
	PORT_DISPLAY |= (1<<DISP_CS);
	PORT_DISPLAY &= ~(1<<DISP_CS);
}

void InitDisplay()
{
	uint8_t addr;

	// Set pin configurations
	DDR_DISPLAY |= DISPLAY_ALLPINS;
	PORT_DISPLAY &= ~DISPLAY_ALLPINS;

	Send( (ADDR_DECODEMODE << 8) | DIG_ALL );
	Send( (ADDR_SCANLIMIT <<8) | 7 );
	Send( (ADDR_INTENSITY << 8) | 8 );

	// Clear Display
	for(addr=1; addr<=8; addr++)
	{
		Send( (addr << 8) | CODE_BLANK);
	}

	Send( (ADDR_SHUTDOWN << 8) | NORMALMODE );
}


void SendDigits(uint8_t values[])
{
	uint8_t addr;

	for(addr=1; addr<=8; addr++)
	{
		Send( (addr << 8) | values[addr-1]);
	}
}
