/*
 * display.h
 *
 *  Created on: Oct 20, 2015
 *      Author: NMR
 */

#ifndef DISPLAY_H_
#define DISPLAY_H_

#include <avr/io.h>
#include <stdint.h>

#ifndef F_CPU
#warning F_CPU not defined. Needed in library max7219.h
#endif

/* Port and pin definitions */
#define PORT_DISPLAY    PORTD
#define DDR_DISPLAY     DDRD

#define DISP_CLK        PD6
#define DISP_DATA       PD5
#define DISP_CS         PD4

#define DISPLAY_ALLPINS ((1<<DISP_CLK) | (1<<DISP_DATA) | (1<<DISP_CS))

/* MAX7219 register table */
#define ADDR_NOOP       0x00
#define ADDR_DIGIT0     0x01
#define ADDR_DIGIT1     0x02
#define ADDR_DIGIT2     0x03
#define ADDR_DIGIT3     0x04
#define ADDR_DIGIT4     0x05
#define ADDR_DIGIT5     0x06
#define ADDR_DIGIT6     0x07
#define ADDR_DIGIT7     0x08
#define ADDR_DECODEMODE 0x09
#define ADDR_INTENSITY  0x0A
#define ADDR_SCANLIMIT  0x0B
#define ADDR_SHUTDOWN   0x0C
#define ADDR_DISPTEST   0x0F

/* MAX7219 operation modes */
#define SHUTDOWNMODE    0x00
#define NORMALMODE      0x01

/* MAX7219 special characters */
#define CODE_DP         0x80
#define CODE_MINUS      0x0A
#define CODE_E          0x0B
#define CODE_H          0x0C
#define CODE_L          0x0D
#define CODE_P          0x0E
#define CODE_BLANK      0x0F

#define DIG_ALL         0xFF
#define DIG_NONE        0x00

void Send(uint16_t data);
void InitDisplay(void);
void SendDigits(uint8_t values[]);

#endif /* DISPLAY_H_ */
